=== debian/changelog ===
gr-gsm (0.42.2-1) unstable; urgency=medium

  * New upstream version 0.42.2.
  * Changed Standards-Version from 4.1.4 to 4.2.0.
  * Removed 0000-soname-0-42-1.patch applied upstream.

 -- Petter Reinholdtsen <pere@debian.org>  Sat, 18 Aug 2018 19:20:42 +0200

gr-gsm (0.42.1-2) unstable; urgency=medium

  * Update build depend list based on pacages in Debian_testing.docker to
    fix build failure.

 -- Petter Reinholdtsen <pere@debian.org>  Sat, 11 Aug 2018 13:55:50 +0200

gr-gsm (0.42.1-1) unstable; urgency=medium

  * New upstream version 0.42.1
   - Fixes python import problem (Closes: #890914)
  * New upstream URL.  Updated d/control and d/copyright.
  * Updated watch file to use new upstream location.
  * Removed 1010-hackrf-scanner.patch now applied upstream.
  * Updated Standards-Version from 4.1.0 to 4.1.4.
  * Added 0000-soname-0-42-1.patch from upstream to correct library soname.

 -- Petter Reinholdtsen <pere@debian.org>  Sat, 11 Aug 2018 05:10:02 +0000

gr-gsm (0.41.2-2) unstable; urgency=medium

  * Add doxygen as build dependency to include documentation in package.
  * Added 1010-hackrf-scanner.patch to stop grgsm_scanner from crashing
    with HackRF.
  * Added 1020-reproducible-build.patch to make build timestamp more
    reproducible (Closes: 891405)
  * Update Vcs links to salsa.
  * Changed debhelper compat level from 9 to  10.
  * Remove no longer needed --parallel from d/rules.  Thanks lintian.

 -- Petter Reinholdtsen <pere@debian.org>  Wed, 21 Mar 2018 08:41:10 +0000
